#pragma once

#include <QPlainTextEdit>

class CodeWidget : public QPlainTextEdit {
    Q_OBJECT
public:
    explicit CodeWidget(QWidget *parent = 0);
    explicit CodeWidget(const QString& text, QWidget *parent = 0);
    virtual ~CodeWidget();

    void areaPaintEvent(QPaintEvent *event);
    qint32 areaWidth() const;

protected:
    virtual void resizeEvent(QResizeEvent *event) override;

    void setupActions();

protected slots:
    void updateAreaWidth(qint32 block_count);
    void highlightLine();
    void updateArea(const QRect& rect, qint32 dy);

private:
    QWidget *_area;
};

class LinesArea : public QWidget {
    Q_OBJECT
public:
    explicit LinesArea(CodeWidget *parent);
    virtual ~LinesArea();

    QSize sizeHint() const;

protected:
    virtual void paintEvent(QPaintEvent *event) override;

private:
    CodeWidget *_parent;
};
