#pragma once

#include <QWidget>

namespace Ui
{
    class HexWidget;
}

class HexWidget : public QWidget {
    Q_OBJECT
public:
    explicit HexWidget(QWidget *parent = 0);
    virtual ~HexWidget();

    QByteArray hexData() const;
    void setHexData(const QByteArray& data);

public slots:
    void slotRefreshViews();

    void slotSelectCellDLine(qint32 row, qint32 col);
    void slotSelectCellHex(qint32 row, qint32 col);
    void slotSelectCellAsc(qint32 row, qint32 col);
    void slotSelectCellHLine(qint32 row, qint32 col);

    void slotScrollDLine(qint32 val);
    void slotScrollHex(qint32 val);
    void slotScrollAsc(qint32 val);
    void slotScrollHLine(qint32 val);

protected:
    virtual void changeEvent(QEvent *event);
    void setupActions();

private:
    Ui::HexWidget *_ui;
    QByteArray _data;
    qint32 _width;
};
