#include <QLineEdit>
#include "Latin1Delegate.hxx"

// --- internal constants ---

const QRegExpValidator VLatin1(QRegExp("\\S"));

// --- constructors and deconstructors ---

Latin1Delegate::Latin1Delegate(QObject *parent)
: QStyledItemDelegate(parent)
{
}

Latin1Delegate::~Latin1Delegate()
{
}

// --- public methods ---

QWidget *Latin1Delegate::createEditor(QWidget *parent, const QStyleOptionViewItem& /*option*/,
    const QModelIndex& /*index*/) const
{
    QLineEdit *editor = new QLineEdit(parent);

    editor->setValidator(&VLatin1);
    editor->setFrame(false);

    return editor;
}

void Latin1Delegate::setEditorData(QWidget *editor, const QModelIndex& index) const
{
    QLineEdit *ed = static_cast<QLineEdit *>(editor);
    const qint32 chr = index.model()->data(index, Qt::EditRole).toInt();

    ed->setText(QChar(chr));
}

void Latin1Delegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex& index) const
{
    QLineEdit *ed = static_cast<QLineEdit *>(editor);

    model->setData(index, ed->text(), Qt::EditRole);
}

void Latin1Delegate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem& option,
    const QModelIndex& /*index*/) const
{
    editor->setGeometry(option.rect);
}
