#pragma once

#include <QMainWindow>
#include "filesystem/NCFile.hxx"

namespace Ui
{
    class DatWindow;
}

class DatWindow : public QMainWindow {
    Q_OBJECT
signals:
    void sigDatUpdate(NCFile& entry, quint32 row) const;
    void sigDatIgnored() const;

public:
    enum class Mode : quint8 {
        Fresh,
        Edited
    };

    explicit DatWindow(QWidget *parent = 0);
    virtual ~DatWindow();

public slots:
    void slotDatSave();
    void slotDatDiscard();

    void slotDatView(NCFile& entry, quint32 row);

protected:
    virtual void changeEvent(QEvent *event);
    void setMode(const Mode mode = Mode::Fresh);
    void setupActions();

private:
    Ui::DatWindow *_ui;
    NCFile _entry;
    quint32 _num;
};
