#pragma once

#include <QSyntaxHighlighter>

class DefSyntax : public QSyntaxHighlighter {
    Q_OBJECT
public:
    explicit DefSyntax(QObject *parent = 0);
    explicit DefSyntax(QTextDocument *parent = 0);
    virtual ~DefSyntax();

protected:
    virtual void highlightBlock(const QString& text) override;
    void setup();

private:
    QTextCharFormat _keywords_f;
    QTextCharFormat _ints_f;
    QTextCharFormat _floats_f;
    QTextCharFormat _strings_f;
    QTextCharFormat _comment_f;
    QRegExp _keywords_re;
    QRegExp _ints_re;
    QRegExp _floats_re;
    QRegExp _strings_re;
    QRegExp _comment_re;
};
