#pragma once

#include <QMainWindow>
#include "filesystem/NCFile.hxx"

namespace Ui
{
    class TextWindow;
}
class QSyntaxHighlighter;

class TextWindow : public QMainWindow {
    Q_OBJECT
signals:
    void sigTextUpdate(NCFile& entry, quint32 row) const;
    void sigTextIgnored() const;

public:
    // internal typedefs
    enum class Mode : quint8 {
        Fresh,
        Edited
    };

    // constructors and deconstructors
    explicit TextWindow(QWidget *parent = 0);
    virtual ~TextWindow();

public slots:
    void slotTextSave();
    void slotTextDiscard();

    void slotEditDelete();

    void slotTextView(NCFile& entry, quint32 row);
    void slotTextChanged();

protected:
    virtual void changeEvent(QEvent *event);
    void setMode(const Mode mode = Mode::Fresh);
    void setupActions();

private:
    Ui::TextWindow *_ui;
    QSyntaxHighlighter *_syn;
    NCFile _entry;
    quint32 _num;
};
