#pragma once

#include <QSyntaxHighlighter>

class TscSyntax : public QSyntaxHighlighter {
    Q_OBJECT
public:
    explicit TscSyntax(QObject *parent = 0);
    explicit TscSyntax(QTextDocument *parent = 0);
    virtual ~TscSyntax();

protected:
    virtual void highlightBlock(const QString& text) override;
    void setup();

private:
    QTextCharFormat _structs_f;
    QTextCharFormat _functions_f;
    QTextCharFormat _ints_f;
    QTextCharFormat _floats_f;
    QTextCharFormat _strings_f;
    QTextCharFormat _comment_f;
    QTextCharFormat _preprocs_f;
    QRegExp _structs_re;
    QRegExp _functions_re;
    QRegExp _ints_re;
    QRegExp _floats_re;
    QRegExp _strings_re;
    QRegExp _comment_re;
    QRegExp _preprocs_re;
};
