#include <QFile>
#include <QString>
#include <QTextStream>

QTextStream out(stdout);
QTextStream err(stderr);

int main(int argc, char **argv)
{
    if (argc == 2)
    {
        QFile file(argv[1]);

        if (!file.exists())
        {
            err << "ERROR: unable to open file '" << file.fileName() << "'" << endl;
            return 1;
        }

        if (file.open(QIODevice::ReadOnly))
        {
            // black maigc ;-) naaa, we need a quint32 at the beginning of the zlib stream to get qUncompress()
            // to eat it
            const quint32 tmp_size = sizeof (quint32);
            QByteArray stream(file.size() + tmp_size, '\0');

            file.read(stream.data() + 4, file.size());
            file.close();

            if (stream[tmp_size] != 'x')
            {
                err << "ERROR: file '" << file.fileName() << "' is not zlib compressed" << endl;
                return 1;
            }

            stream = qUncompress(stream);

            file.setFileName(file.fileName() + ".decompressed");
            if (file.open(QIODevice::WriteOnly))
            {
                file.write(stream);
                file.close();

                return 0;
            }
            else
            {
                err << "ERROR: file '" << file.fileName() << "' is not writeable" << endl;
                return 1;
            }
        }
        else
        {
            err << "ERROR: file '" << file.fileName() << "' is not readable" << endl;
            return 1;
        }
    }

    out << "usage: " << argv[0] << " <.z file to decompress>" << endl;

    return 0;
}
